var app = function() {
    var _this = this;
    _this.acual = 0;
    _this.max = appConfig.slides.length;
    _this.nav = 0;
    _this.menu = _this.acual;
    _this.animate = 0;
    _this.appLoaded = 0;
    _this.soundRedy = 0;
    _this.musicOn = 1;

    _this.init = function() {
        _this.gui();

        _this.drawNav();

        _this.preload(function(){
            _this.generateSlides();
            _this.makeScreen(_this.acual);
        })
    }

    _this.drawNav = function() {
        $('.numbers').html('');
        var count = appConfig.slides.length>5?5:appConfig.slides.length;
        var min=_this.menu;
        for(var i=0;i<count;i++) {
            $('.numbers').append('<a href="javascript: void(0);" style="color: #e0e0e0; text-decoration: none;" class="num" data-id="'+(min+i)+'" alt="Слайд № '+(i+1)+'">'+(min+i+1)+'</a>');
        }
        $('.numbers .num').removeClass('active');
        $('.numbers .num[data-id="'+_this.acual+'"]').addClass('active');
        $('.numbers .num').click(function(e){
            e.preventDefault();
            var dest = parseInt($(this).attr('data-id'));
            _this.makeScreen(dest);
        });
    }

    _this.generateSlides = function() {
        $('.slides').html('');
        for(var i=0; i < appConfig.slides.length; i++) {
            var slide = appConfig.slides[i],
                html;
            switch (slide.type) {
                case 'gossarymenu': html = _this.generateGlossarymenuSlide(slide); break;
                case 'start': html = _this.generateStartSlide(); break;
                case 'end': html = _this.generateEndSlide(); break;
            }
            html.addClass('slide-'+i);
            $('.slides').append(html);
        }
    }

    _this.generateStartSlide = function() {
        var html = $('<div class="startSlide"><a alt="старт" href="javascript: void(0);" style="color: #e0e0e0; text-decoration: none;" class="btn-start"><img src="assets/img/skin/ribbon-small.png"><span>старт</span></a></div>')
        html.find('.btn-start').bind('click tap',function(){
            var dest = _this.acual+1;
            _this.makeScreen(dest);
        })
        return html;
    }

    _this.generateEndSlide = function() {
        var html = $('<div class="endSlide"><h3> Поздравляем</h3><a alt="Повторить" href="javascript: void(0);" style="color: #e0e0e0; text-decoration: none;" class="btn-repeat" ><img src="assets/img/skin/ribbon-small.png"><span style="font-size: 25px; margin-top:10px;">Повторить!</span></a></div>')
        html.find('.btn-repeat').bind('click tap',function(){
            var dest = 0;
            _this.makeScreen(dest);
        })
        return html;
    }

    _this.playSound = function(id) {
        var sound = soundManager.getSoundById(id);
        if(_this.musicOn && !sound.playState) {
            soundManager.stopAll();
            sound.play();
        }
    }

    _this.generateGlossarymenuSlide = function(slide) {
        var html = $('<div class="gossarymenu"></div>')
        var frame = $('<div class="frame"></div>')
        var elements = slide.elements;
        for(var i=0; i<elements.length; i++) {
            var element = elements[i];
            var block = $('<div class="block"></div>');
            block.css({
                'background-color':element.backgroundColor,
                'color': element.textColor
            })
            if(element.name != 'empty') {
             //   block.append('<img src="assets/img/empty.png"" alt="'+element.textColor+'" title="'+element.name+'">').append('<span>'+element.name+'</span>')
                block.append('<a href="javascript: void(0);"><img src="assets/img/'+slide.dir+'/'+element.soundfile+'.png" alt="'+element.name+'" title="'+element.name+'"></a>').append('<span>'+element.name+'</span>')
      
	        } else {
                block.append('<img src="assets/img/empty.png">')
                block.addClass('empty')
            }
            block.attr('data-id',element.name);
            frame.append(block);

            if(_this.soundRedy && element.name!='empty') {
                soundManager.createSound({
                    id: element.name,
                    url: [
                        {type:'audio/mp3',url:'assets/sounds/MP3/'+element.soundfile+'.mp3'},
                        {type:'audio/ogg',url:'assets/sounds/OGG/'+element.soundfile+'.ogg'},
                        {type:'audio/wav',url:'assets/sounds/WAV/'+element.soundfile+'.wav'}
                    ]
                });
            }

        }
        html.append('<div class="title">'+slide.title+'</div>')
            .append(frame)
            .append('<div class="clearfix"></div>');

        frame.find('.block').bind('click tap',function(){
            var id = $(this).attr('data-id');
            if(id!='empty') {
                _this.playSound(id)
            }

        })
        return html;

    }

    _this.gui = function() {
        setTimeout(_this.resize,500);
        $('body, html').bind('resize',function(){
            setTimeout(_this.resize,100);
        });

        $('.appName').text(appConfig.appName)
        $('title').text(appConfig.appTitle)

        for(var key in guiConfig.auto) {
            $(key).attr('alt', guiConfig.auto[key])
                  .attr('title', guiConfig.auto[key])
        }

        _this.bindActions();
    }

    _this.bindActions = function(){
        $('.btn-menu').bind('click tap',function(){
            $('.header .nav').toggleClass('opened')
        })
        $('.controls .btn-help, #tutorial').bind('click tap',function(){
            $('#tutorial').toggleClass('hidden')
        })

        $('.slide-nav .btn-next').click(function(){
            var dest=_this.menu+1;
            var count = appConfig.slides.length>5?5:appConfig.slides.length;
            if(dest+5>_this.max) { dest=_this.max-count; }
            _this.menu = dest;
            _this.drawNav();
        });

        $('.slide-nav .btn-prev').click(function(){
            var dest=_this.menu-1;
            if(dest<0) { dest=0; }
            _this.menu = dest;
            _this.drawNav();
        });

        $('.main-wrap .btn-next-slide').click(function(){
            var dest=_this.acual+1;
            if(dest==_this.max) { dest=_this.max-1; }
            _this.makeScreen(dest);
        });

        $('.main-wrap .btn-prev-slide').click(function(){
            var dest=_this.acual-1;
            if(dest<0) { dest=0; }
            _this.makeScreen(dest);
        });

        $('body').keyup(function (e) {
            if (e.keyCode == 39) {
                var dest=_this.acual+1;
                if(dest==_this.max) { dest=_this.max-1; }
                _this.makeScreen(dest);
            }
            if (e.keyCode == 37) {
                var dest=_this.acual-1;
                if(dest<0) { dest=0; }
                _this.makeScreen(dest);
            }
        });

        $('.footer .btn-sound').bind('click tap',function(){
            if(_this.musicOn) {
                _this.musicOn=0;
                soundManager.mute();
                $(this).find('.sound').removeClass('soundon')
            } else {
                _this.musicOn=1;
                soundManager.unmute();
                $(this).find('.sound').addClass('soundon')            }
        });
    }

    _this.makeScreen = function(number) {
        function cb() {
            _this.acual=number;

            _this.menu=_this.acual-3;
            if(_this.menu<0) { _this.menu=0; }
            if(_this.max-_this.acual<3) { _this.menu=_this.max-(appConfig.slides.length>5?5:appConfig.slides.length); }

            _this.drawNav();

            $('.slide-'+_this.acual).fadeIn(500,function(){
// chowanie
				if(_this.acual>0){
					$(".copywrite").hide();	
				}
//pokazywanie
            
					if(_this.acual==(_this.max-1)){
					$(".copywrite").show();	
				}
                _this.animate = 0;
                _this.resize();
                appConfig.custiomActions(_this)
            });
        }

        if(_this.appLoaded) {
            if(_this.acual!=number && !_this.animate) {
                _this.animate = 1;
                _this.nav=0;

                $('.slide-'+_this.acual).fadeOut(500,cb);
            }
        } else {
            _this.appLoaded = 1;
            cb();
        }

    }

    _this.preload = function(cb) {
        setTimeout(function(){
            $('.preloader').addClass('hidden');
            setTimeout(function(){
                $('.preloader').hide();
                _this.setupMusic(cb)
            })

        },2000)
    }

    _this.resize = function() {
        var minHeight = $('body').height() - $('.header').height() - $('.footer').height() - 20;
        if(minHeight>200) {
            $('.main-wrap').css('min-height',minHeight+'px');
        }
    }

    _this.setupMusic = function(cb) {
        soundManager.setup({
            url: 'assets/swf',
            debugMode: false,
            onready: function() {
                _this.soundRedy = 1;
                cb();
            }
        });
    }

    _this.init();

}

$(document).ready(function(){
    new app();
})